CREATE TABLE IF NOT EXISTS LessonHide (
Id_Lesson				INTEGER 	PRIMARY KEY
);

CREATE TABLE IF NOT EXISTS ExerciseRun (
Id_Exercise 			INTEGER		NOT NULL,
Date_Run 				TEXT		NOT NULL,
Percent_Success 		INTEGER		NOT NULL,
Completed		 		INTEGER		NOT NULL,
PRIMARY KEY (Id_Exercise, Date_Run)
);

CREATE VIEW IF NOT EXISTS BestResultForExercise
AS
SELECT Exercise.Id_Exercise,
	   MAX(Percent_Success) AS Best_Result,
	   MAX(Completed) AS Completed
FROM Exercise
LEFT JOIN ExerciseRun ON (Exercise.Id_Exercise = ExerciseRun.Id_Exercise)
GROUP BY Exercise.Id_Exercise;

CREATE VIEW IF NOT EXISTS LessonProgress 
AS
SELECT Lesson.Id_Lesson,
	   CASE WHEN COUNT(Exercise.Id_Exercise) = 0 THEN NULL ELSE SUM(Best_Result) / COUNT(Exercise.Id_Exercise) END AS Progress,
	   CASE WHEN COUNT(Exercise.Id_Exercise) = 0 THEN 0 WHEN COUNT(Exercise.Id_Exercise) = SUM(Completed) THEN 1 ELSE 0 END AS Completed
FROM Lesson
LEFT JOIN Exercise ON (Lesson.Id_Lesson = Exercise.Id_Lesson)
LEFT JOIN BestResultForExercise ON (Exercise.Id_Exercise = BestResultForExercise.Id_Exercise)
GROUP BY Lesson.Id_Lesson;

CREATE TABLE IF NOT EXISTS LessonHomework (
Id_Lesson				INTEGER 	PRIMARY KEY,
Date_Homework 			TEXT		NOT NULL
);

CREATE TABLE IF NOT EXISTS Diploma (
Id_Diploma				INTEGER 	PRIMARY KEY,
Id_Level 				INTEGER		NOT NULL,
Date_Diploma 			TEXT		NOT NULL
);

CREATE TABLE IF NOT EXISTS LessonDiploma (
Id_Lesson				INTEGER 	PRIMARY KEY,
Id_Diploma 				INTEGER		NOT NULL,
FOREIGN KEY(Id_Diploma) REFERENCES Diploma(Id_Diploma)
);

CREATE TABLE IF NOT EXISTS PiggyBank (
Current_Tokens			INTEGER		NOT NULL,
Total_Tokens				INTEGER		NOT NULL
);
